// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_msgs:msg/CoopAwareness.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cam_msgs/msg/coop_awareness.hpp"


#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__COOP_AWARENESS__STRUCT_HPP_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__COOP_AWARENESS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'generation_delta_time'
#include "etsi_its_cam_msgs/msg/detail/generation_delta_time__struct.hpp"
// Member 'cam_parameters'
#include "etsi_its_cam_msgs/msg/detail/cam_parameters__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_msgs__msg__CoopAwareness __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_msgs__msg__CoopAwareness __declspec(deprecated)
#endif

namespace etsi_its_cam_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CoopAwareness_
{
  using Type = CoopAwareness_<ContainerAllocator>;

  explicit CoopAwareness_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : generation_delta_time(_init),
    cam_parameters(_init)
  {
    (void)_init;
  }

  explicit CoopAwareness_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : generation_delta_time(_alloc, _init),
    cam_parameters(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _generation_delta_time_type =
    etsi_its_cam_msgs::msg::GenerationDeltaTime_<ContainerAllocator>;
  _generation_delta_time_type generation_delta_time;
  using _cam_parameters_type =
    etsi_its_cam_msgs::msg::CamParameters_<ContainerAllocator>;
  _cam_parameters_type cam_parameters;

  // setters for named parameter idiom
  Type & set__generation_delta_time(
    const etsi_its_cam_msgs::msg::GenerationDeltaTime_<ContainerAllocator> & _arg)
  {
    this->generation_delta_time = _arg;
    return *this;
  }
  Type & set__cam_parameters(
    const etsi_its_cam_msgs::msg::CamParameters_<ContainerAllocator> & _arg)
  {
    this->cam_parameters = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_msgs__msg__CoopAwareness
    std::shared_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_msgs__msg__CoopAwareness
    std::shared_ptr<etsi_its_cam_msgs::msg::CoopAwareness_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CoopAwareness_ & other) const
  {
    if (this->generation_delta_time != other.generation_delta_time) {
      return false;
    }
    if (this->cam_parameters != other.cam_parameters) {
      return false;
    }
    return true;
  }
  bool operator!=(const CoopAwareness_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CoopAwareness_

// alias to use template instance with default allocator
using CoopAwareness =
  etsi_its_cam_msgs::msg::CoopAwareness_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_msgs

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__COOP_AWARENESS__STRUCT_HPP_
