// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_msgs:msg/PositionOfOccupants.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cam_msgs/msg/position_of_occupants.hpp"


#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__POSITION_OF_OCCUPANTS__STRUCT_HPP_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__POSITION_OF_OCCUPANTS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_msgs__msg__PositionOfOccupants __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_msgs__msg__PositionOfOccupants __declspec(deprecated)
#endif

namespace etsi_its_cam_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PositionOfOccupants_
{
  using Type = PositionOfOccupants_<ContainerAllocator>;

  explicit PositionOfOccupants_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  explicit PositionOfOccupants_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  // field types and members
  using _value_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _value_type value;
  using _bits_unused_type =
    uint8_t;
  _bits_unused_type bits_unused;

  // setters for named parameter idiom
  Type & set__value(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__bits_unused(
    const uint8_t & _arg)
  {
    this->bits_unused = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t SIZE_BITS =
    20u;
  static constexpr uint8_t BIT_INDEX_ROW1_LEFT_OCCUPIED =
    0u;
  static constexpr uint8_t BIT_INDEX_ROW1_RIGHT_OCCUPIED =
    1u;
  static constexpr uint8_t BIT_INDEX_ROW1_MID_OCCUPIED =
    2u;
  static constexpr uint8_t BIT_INDEX_ROW1_NOT_DETECTABLE =
    3u;
  static constexpr uint8_t BIT_INDEX_ROW1_NOT_PRESENT =
    4u;
  static constexpr uint8_t BIT_INDEX_ROW2_LEFT_OCCUPIED =
    5u;
  static constexpr uint8_t BIT_INDEX_ROW2_RIGHT_OCCUPIED =
    6u;
  static constexpr uint8_t BIT_INDEX_ROW2_MID_OCCUPIED =
    7u;
  static constexpr uint8_t BIT_INDEX_ROW2_NOT_DETECTABLE =
    8u;
  static constexpr uint8_t BIT_INDEX_ROW2_NOT_PRESENT =
    9u;
  static constexpr uint8_t BIT_INDEX_ROW3_LEFT_OCCUPIED =
    10u;
  static constexpr uint8_t BIT_INDEX_ROW3_RIGHT_OCCUPIED =
    11u;
  static constexpr uint8_t BIT_INDEX_ROW3_MID_OCCUPIED =
    12u;
  static constexpr uint8_t BIT_INDEX_ROW3_NOT_DETECTABLE =
    13u;
  static constexpr uint8_t BIT_INDEX_ROW3_NOT_PRESENT =
    14u;
  static constexpr uint8_t BIT_INDEX_ROW4_LEFT_OCCUPIED =
    15u;
  static constexpr uint8_t BIT_INDEX_ROW4_RIGHT_OCCUPIED =
    16u;
  static constexpr uint8_t BIT_INDEX_ROW4_MID_OCCUPIED =
    17u;
  static constexpr uint8_t BIT_INDEX_ROW4_NOT_DETECTABLE =
    18u;
  static constexpr uint8_t BIT_INDEX_ROW4_NOT_PRESENT =
    19u;

  // pointer types
  using RawPtr =
    etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_msgs__msg__PositionOfOccupants
    std::shared_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_msgs__msg__PositionOfOccupants
    std::shared_ptr<etsi_its_cam_msgs::msg::PositionOfOccupants_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PositionOfOccupants_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    if (this->bits_unused != other.bits_unused) {
      return false;
    }
    return true;
  }
  bool operator!=(const PositionOfOccupants_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PositionOfOccupants_

// alias to use template instance with default allocator
using PositionOfOccupants =
  etsi_its_cam_msgs::msg::PositionOfOccupants_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::SIZE_BITS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW1_LEFT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW1_RIGHT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW1_MID_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW1_NOT_DETECTABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW1_NOT_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW2_LEFT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW2_RIGHT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW2_MID_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW2_NOT_DETECTABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW2_NOT_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW3_LEFT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW3_RIGHT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW3_MID_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW3_NOT_DETECTABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW3_NOT_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW4_LEFT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW4_RIGHT_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW4_MID_OCCUPIED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW4_NOT_DETECTABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PositionOfOccupants_<ContainerAllocator>::BIT_INDEX_ROW4_NOT_PRESENT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_msgs

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__POSITION_OF_OCCUPANTS__STRUCT_HPP_
