﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_msgs:msg/BasicVehicleContainerHighFrequency.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cam_msgs/msg/basic_vehicle_container_high_frequency.h"


#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_H_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'heading'
#include "etsi_its_cam_msgs/msg/detail/heading__struct.h"
// Member 'speed'
#include "etsi_its_cam_msgs/msg/detail/speed__struct.h"
// Member 'drive_direction'
#include "etsi_its_cam_msgs/msg/detail/drive_direction__struct.h"
// Member 'vehicle_length'
#include "etsi_its_cam_msgs/msg/detail/vehicle_length__struct.h"
// Member 'vehicle_width'
#include "etsi_its_cam_msgs/msg/detail/vehicle_width__struct.h"
// Member 'longitudinal_acceleration'
#include "etsi_its_cam_msgs/msg/detail/longitudinal_acceleration__struct.h"
// Member 'curvature'
#include "etsi_its_cam_msgs/msg/detail/curvature__struct.h"
// Member 'curvature_calculation_mode'
#include "etsi_its_cam_msgs/msg/detail/curvature_calculation_mode__struct.h"
// Member 'yaw_rate'
#include "etsi_its_cam_msgs/msg/detail/yaw_rate__struct.h"
// Member 'acceleration_control'
#include "etsi_its_cam_msgs/msg/detail/acceleration_control__struct.h"
// Member 'lane_position'
#include "etsi_its_cam_msgs/msg/detail/lane_position__struct.h"
// Member 'steering_wheel_angle'
#include "etsi_its_cam_msgs/msg/detail/steering_wheel_angle__struct.h"
// Member 'lateral_acceleration'
#include "etsi_its_cam_msgs/msg/detail/lateral_acceleration__struct.h"
// Member 'vertical_acceleration'
#include "etsi_its_cam_msgs/msg/detail/vertical_acceleration__struct.h"
// Member 'performance_class'
#include "etsi_its_cam_msgs/msg/detail/performance_class__struct.h"
// Member 'cen_dsrc_tolling_zone'
#include "etsi_its_cam_msgs/msg/detail/cen_dsrc_tolling_zone__struct.h"

/// Struct defined in msg/BasicVehicleContainerHighFrequency in the package etsi_its_cam_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_msgs__msg__BasicVehicleContainerHighFrequency
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// BasicVehicleContainerHighFrequency ::= SEQUENCE {
  ///  heading Heading,
  ///  speed Speed,
  ///  driveDirection DriveDirection,
  ///  vehicleLength VehicleLength,
  ///  vehicleWidth VehicleWidth,
  ///  longitudinalAcceleration LongitudinalAcceleration,
  ///  curvature Curvature,
  ///  curvatureCalculationMode CurvatureCalculationMode,
  ///  yawRate YawRate,
  ///  accelerationControl AccelerationControl OPTIONAL,
  ///  lanePosition LanePosition OPTIONAL,
  ///  steeringWheelAngle SteeringWheelAngle OPTIONAL,
  ///  lateralAcceleration LateralAcceleration OPTIONAL,
  ///  verticalAcceleration VerticalAcceleration OPTIONAL,
  ///  performanceClass PerformanceClass OPTIONAL,
  ///  cenDsrcTollingZone CenDsrcTollingZone OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cam_msgs__msg__Heading heading;
  etsi_its_cam_msgs__msg__Speed speed;
  etsi_its_cam_msgs__msg__DriveDirection drive_direction;
  etsi_its_cam_msgs__msg__VehicleLength vehicle_length;
  etsi_its_cam_msgs__msg__VehicleWidth vehicle_width;
  etsi_its_cam_msgs__msg__LongitudinalAcceleration longitudinal_acceleration;
  etsi_its_cam_msgs__msg__Curvature curvature;
  etsi_its_cam_msgs__msg__CurvatureCalculationMode curvature_calculation_mode;
  etsi_its_cam_msgs__msg__YawRate yaw_rate;
  etsi_its_cam_msgs__msg__AccelerationControl acceleration_control;
  bool acceleration_control_is_present;
  etsi_its_cam_msgs__msg__LanePosition lane_position;
  bool lane_position_is_present;
  etsi_its_cam_msgs__msg__SteeringWheelAngle steering_wheel_angle;
  bool steering_wheel_angle_is_present;
  etsi_its_cam_msgs__msg__LateralAcceleration lateral_acceleration;
  bool lateral_acceleration_is_present;
  etsi_its_cam_msgs__msg__VerticalAcceleration vertical_acceleration;
  bool vertical_acceleration_is_present;
  etsi_its_cam_msgs__msg__PerformanceClass performance_class;
  bool performance_class_is_present;
  etsi_its_cam_msgs__msg__CenDsrcTollingZone cen_dsrc_tolling_zone;
  bool cen_dsrc_tolling_zone_is_present;
} etsi_its_cam_msgs__msg__BasicVehicleContainerHighFrequency;

// Struct for a sequence of etsi_its_cam_msgs__msg__BasicVehicleContainerHighFrequency.
typedef struct etsi_its_cam_msgs__msg__BasicVehicleContainerHighFrequency__Sequence
{
  etsi_its_cam_msgs__msg__BasicVehicleContainerHighFrequency * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_msgs__msg__BasicVehicleContainerHighFrequency__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__BASIC_VEHICLE_CONTAINER_HIGH_FREQUENCY__STRUCT_H_
