﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_msgs:msg/LateralAccelerationValue.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cam_msgs/msg/lateral_acceleration_value.h"


#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__LATERAL_ACCELERATION_VALUE__STRUCT_H_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__LATERAL_ACCELERATION_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_msgs__msg__LateralAccelerationValue__MIN = -160
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_msgs__msg__LateralAccelerationValue__MAX = 161
};

/// Constant 'POINT_ONE_METER_PER_SEC_SQUARED_TO_RIGHT'.
enum
{
  etsi_its_cam_msgs__msg__LateralAccelerationValue__POINT_ONE_METER_PER_SEC_SQUARED_TO_RIGHT = -1
};

/// Constant 'POINT_ONE_METER_PER_SEC_SQUARED_TO_LEFT'.
enum
{
  etsi_its_cam_msgs__msg__LateralAccelerationValue__POINT_ONE_METER_PER_SEC_SQUARED_TO_LEFT = 1
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_msgs__msg__LateralAccelerationValue__UNAVAILABLE = 161
};

/// Struct defined in msg/LateralAccelerationValue in the package etsi_its_cam_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_msgs__msg__LateralAccelerationValue
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LateralAccelerationValue ::= INTEGER {pointOneMeterPerSecSquaredToRight(-1), pointOneMeterPerSecSquaredToLeft(1), unavailable(161)} (-160 .. 161)
  /// ------------------------------------------------------------------------------
  int16_t value;
} etsi_its_cam_msgs__msg__LateralAccelerationValue;

// Struct for a sequence of etsi_its_cam_msgs__msg__LateralAccelerationValue.
typedef struct etsi_its_cam_msgs__msg__LateralAccelerationValue__Sequence
{
  etsi_its_cam_msgs__msg__LateralAccelerationValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_msgs__msg__LateralAccelerationValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__LATERAL_ACCELERATION_VALUE__STRUCT_H_
